SystemOrganization addCategory: #'ObjectDiff-OD'!
SystemOrganization addCategory: #'ObjectDiff-OD-Test'!
SystemOrganization addCategory: #'ObjectDiff-Sheet'!
SystemOrganization addCategory: #'ObjectDiff-Sheet-Test'!
SystemOrganization addCategory: #'ObjectDiff-Sheet-GUI'!
SystemOrganization addCategory: #'ObjectDiff-System'!
SystemOrganization addCategory: #ObjectDiff!
SystemOrganization addCategory: #'ObjectDiff-Test'!
SystemOrganization addCategory: #'ObjectDiff-GUI'!

!Set methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 23:10'!
objectDiffKeys
^self isEmpty
	ifTrue: [Array new]
	ifFalse: [1 to: self size]! !

!Set methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:32'!
objectDiffValueAt: anInteger 
^self asArray at: anInteger ! !

!Dictionary methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 23:08'!
objectDiffKeys
^self keys! !

!Dictionary methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:22'!
objectDiffValueAt: anObject
^self at: anObject! !

!Array methodsFor: '*ObjectDiff' stamp: 'HwaJong 10/28/2012 14:15'!
literalForm
^self collect: #literalForm! !

TestCase subclass: #DiffSheetTest
	instanceVariableNames: 's'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

DiffSheetTest subclass: #DSEqualPointsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSEqualPointsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:19'!
setUp
super setUp.
s leftSideObject: 2@3.
s rightSideObject: 2@3.
! !

!DSEqualPointsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:20'!
testCanOpenInnerDifference
self deny: (s canOpenInnerDifference).
self deny: (s canOpenInnerDifferenceAtKey: 'x').
self deny: (s canOpenInnerDifferenceAtKey: 'y').! !

!DSEqualPointsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:19'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #equal.! !

!DSEqualPointsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 23:30'!
testListAt1
self assert: (s listItemOfKeyAtRow: 1) equals: #equal! !

!DSEqualPointsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:52'!
testListRowSize
self assert: s listRowSize equals: 1! !

DiffSheetTest subclass: #DSIdenticalIntegersTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSIdenticalIntegersTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:21'!
setUp
super setUp.
s leftSideObject: 37.
s rightSideObject: 37.
! !

!DSIdenticalIntegersTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:22'!
testCanOpenInnerDifference
self deny: (s canOpenInnerDifference).
self deny: (s canOpenInnerDifferenceAtKey: 'foo').
! !

!DSIdenticalIntegersTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:22'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #identical.! !

!DSIdenticalIntegersTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 23:32'!
testListAt1
self assert: (s listItemOfLeftSideAtRow: 1) equals: '37'! !

!DSIdenticalIntegersTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:52'!
testListRowSize
self assert: s listRowSize equals: 1! !

DiffSheetTest subclass: #DSLeftShortStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSLeftShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:28'!
setUp
super setUp.
s leftSideObject: 'hell'.
s rightSideObject: 'hello'.
! !

!DSLeftShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:28'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #(#(#class #same) #(1 #identical) #(2 #identical) #(3 #identical) #(4 #identical) #(5 #leftMissing)) ! !

!DSLeftShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 23:35'!
testListAt1
self assert: (s listItemOfLeftSideAtRow: 1) equals: '''hell'''! !

!DSLeftShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:52'!
testListRowSize
"'hello'
String
1
2
3
4
5
"
self assert: s listRowSize equals: 7! !

DiffSheetTest subclass: #DSRightDifferentRectanglesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:23'!
setUp
super setUp.
s leftSideObject: (2@3 corner: 10@15).
s rightSideObject: (2@3 corner: 20@15).
! !

!DSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:24'!
testCanOpenInnerDifference
self assert: (s canOpenInnerDifference).
self deny: (s canOpenInnerDifferenceAtKey: 'origin').
self assert: (s canOpenInnerDifferenceAtKey: 'corner').
! !

!DSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:24'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #(#(#class #same) #('origin' #equal) #('corner' #different)).
! !

!DSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:52'!
testListRowSize
self assert: s listRowSize equals: 4! !

!DSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:25'!
testOpenInnerDifferenceAtKey
| indi |
indi := (s openInnerDifferenceAtKey: 'corner').
self assert: indi comparisonResultInLiterals equals: #(#(#class #same) #('x' #different) #('y' #identical))! !

DiffSheetTest subclass: #DSRightShortStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSRightShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:29'!
setUp
super setUp.
s leftSideObject: 'hello'.
s rightSideObject: 'hell'.
! !

!DSRightShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:29'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #(#(#class #same) #(1 #identical) #(2 #identical) #(3 #identical) #(4 #identical) #(5 #rightMissing)) 
! !

!DSRightShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:52'!
testListRowSize
"'hello'
String
1
2
3
4
5
"
self assert: s listRowSize equals: 7! !

DiffSheetTest subclass: #DSSameLengthStringsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSSameLengthStringsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:26'!
setUp
super setUp.
s leftSideObject: 'hell'.
s rightSideObject: 'llll'.
! !

!DSSameLengthStringsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:27'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #(#(#class #same) #(1 #different) #(2 #different) #(3 #identical) #(4 #identical)) 
! !

!DSSameLengthStringsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:52'!
testListRowSize
"'hell'
String
1
2
3
4
"
self assert: s listRowSize equals: 6! !

!DiffSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 16:59'!
setUp
super setUp.
s := DiffSheet new.! !

TestCase subclass: #ODSheetTest
	instanceVariableNames: 'sheet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet-Test'!

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:34'!
setUp
super setUp.
sheet := ODSheet new.
sheet objects: {'hello'. 19. World}.
sheet accesses: {[:o| o sizeInMemory]. [:o| o className]. [:o| o even]}.
! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:35'!
testValueAt1At1
self assert: (sheet valueOfObjectAt: 1 byAccessAt: 1) equals: 9! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:31'!
testValueAt1At2
self assert: (sheet valueOfObjectAt: 1 byAccessAt: 2) equals: 'ByteString'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:29'!
testValueAt1At3
self assert: ((sheet valueOfObjectAt: 1 byAccessAt: 3) isKindOf: MessageNotUnderstood).! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:35'!
testValueAt2At1
self assert: (sheet valueOfObjectAt: 2 byAccessAt: 1) equals: 0! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:36'!
testValueAt2At2
self assert: (sheet valueOfObjectAt: 2 byAccessAt: 2) equals: 'SmallInteger'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:39'!
testValueAt2At3
self deny: (sheet valueOfObjectAt: 2 byAccessAt: 3).! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:36'!
testValueAt3At1
self assert: (sheet valueOfObjectAt: 3 byAccessAt: 1) equals: 52! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:37'!
testValueAt3At2
self assert: (sheet valueOfObjectAt: 3 byAccessAt: 2) equals: 'PasteUpMorph'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:39'!
testValueAt3At3
self assert: ((sheet valueOfObjectAt: 3 byAccessAt: 3) isKindOf: MessageNotUnderstood).! !

TestCase subclass: #ODiffyArrayArrayTest
	instanceVariableNames: 'array1 array2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!ODiffyArrayArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:08'!
setUp
|o|
super setUp.
o := 1@2.
array1 := Array with: 1 with: 3 with: 3/4 with: (o extent: 7@8).
array2 := Array with: 3 with: 3 with: 3/4 with: (o extent: 7@7).! !

!ODiffyArrayArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:15'!
testArray
|d e|
d := OArrayDiffy new.
d leftSideObject: array1.
d rightSideObject: array2.
e := d elementDiffies.
self assert: e size equals: 4.
(e at: 1) ifIdentical: [self fail] ifEqual: [self fail]  ifDifferent: [].
(e at: 2) ifIdentical: [] ifEqual: [self fail]  ifDifferent: [self fail].
(e at: 3) ifIdentical: [self fail] ifEqual: []  ifDifferent: [self fail].
(e at: 4) ifIdentical: [self fail] ifEqual: [self fail]  ifDifferent: [].! !

!ODiffyArrayArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:15'!
testArrayAt4
|d e r|
d := OArrayDiffy new.
d leftSideObject: array1.
d rightSideObject: array2.
e := d elementDiffies.
r := (e at: 4) diffies.
self assert: r size equals: 2.
self assert: ((r at: 1) instVarName) equals: 'origin'.
(r at: 1) ifIdentical: [] ifEqual: [self fail]  ifDifferent: [self fail].
self assert: ((r at: 2) instVarName) equals: 'corner'.
(r at: 2) ifIdentical: [self fail] ifEqual: [self fail]  ifDifferent: [].
! !

TestCase subclass: #ODiffyIVarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!ODiffyIVarTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:38'!
test2Rects
|d o r1 r2 i |
o := 1@2.
r1 := o extent: 3@4.
r2 := o extent: 3@3.
d:=ODiffy new.
d leftSideObject: r1.
d rightSideObject: r2.
i := d ivarDiffies.
self assert: i size equals: 2.
self assert: 'origin' equals: (i at: 1) instVarName.
self assert: 'corner' equals: (i at: 2) instVarName.

(i at: 1) ifIdentical: [] ifEqual: [self fail] ifDifferent: [self fail].
(i at: 2) ifIdentical: [self fail] ifEqual: [self fail] ifDifferent: [].! !

!ODiffyIVarTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:03'!
test2RectsAgain
|d o r1 r2 i |
o := 1@2.
r1 := o extent: 3@4.
r2 := o extent: 3@3.
d:=ODiffy new.
d leftSideObject: r1.
d rightSideObject: r2.
i := (d ivarDiffies at: 2) ivarDiffies.
self assert: i size equals: 2.
self assert: 'x' equals: (i at: 1) instVarName.
(i at: 1) ifIdentical: [] ifEqual: [self fail] ifDifferent: [self fail].
self assert: 'y' equals: (i at: 2) instVarName.
(i at: 2) ifIdentical: [self fail] ifEqual: [self fail] ifDifferent: [].
! !

TestCase subclass: #ODiffyObjectObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!ODiffyObjectObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:25'!
testDifferent

	|d|
	d := ODiffy new.
	d leftSideObject: (3@4 extent: 1@2).
	d rightSideObject: (1@2 extent: 10@5).
	d ifIdentical: [self fail] ifEqual: [self fail] ifDifferent: [].! !

!ODiffyObjectObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:24'!
testEqual

	|d|
	d := ODiffy new.
	d leftSideObject: (1@2 extent: 3@4).
	d rightSideObject: (1@2 extent: 3@4).
	d ifIdentical: [self fail] ifEqual: [] ifDifferent: [self fail].! !

!ODiffyObjectObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:26'!
testIdentical

	|d r|
	r := 1@2 extent: 3@4.
	d := ODiffy new.
	d leftSideObject: r.
	d rightSideObject: r.
	d ifIdentical: [] ifEqual: [self fail] ifDifferent: [self fail].! !

TestCase subclass: #ODiffyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!ODiffyTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:20'!
testDifferent

	|d|
	d := ODiffy new.
	d leftSideObject: 3.
	d rightSideObject: 4.
	d ifIdentical: [self fail] ifEqual: [self fail] ifDifferent: [].! !

!ODiffyTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:21'!
testEqual

	|d|
	d := ODiffy new.
	d leftSideObject: 3/4.
	d rightSideObject: 3/4.
	d ifIdentical: [self fail] ifEqual: [] ifDifferent: [self fail].! !

!ODiffyTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:19'!
testIdentical

	|d|
	d := ODiffy new.
	d leftSideObject: 3.
	d rightSideObject: 3.
	d ifIdentical: [] ifEqual: [self fail] ifDifferent: [self fail].! !

TestCase subclass: #OIvarReferenceTest
	instanceVariableNames: 'rectangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!OIvarReferenceTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:48'!
setUp
super setUp.
rectangle := 1@2 corner: 10@20.! !

!OIvarReferenceTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:54'!
testCorner

self assert: ((OIvarReference object: rectangle instVarName: 'corner')
			value)
	equals: rectangle corner.! !

!OIvarReferenceTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:52'!
testOrigin

self assert: ((OIvarReference object: rectangle instVarName: 'origin')
			value)
	equals: rectangle origin.! !

TestCase subclass: #ObjectDiffSystemTest
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

ObjectDiffSystemTest subclass: #ODSArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:17'!
setUp
super setUp.
object := #(10 20 30 40).! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:06'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: (1 to: 4)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt1
self assert: (object objectDiffValueAt: 1) equals: (10)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt2
self assert: (object objectDiffValueAt: 2) equals: (20)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt3
self assert: (object objectDiffValueAt: 3) equals: (30)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt4
self assert: (object objectDiffValueAt: 4) equals: (40)! !

ObjectDiffSystemTest subclass: #ODSDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:06'!
setUp
super setUp.
object := Dictionary new.
object at: 'hello' put: 'kitty'.
object at: 30 put: 'thirty'.
! !

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:07'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: {30. 'hello'}! !

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:22'!
testObjectDiffValueAt30
self assert: (object objectDiffValueAt: 30) equals: ('thirty')! !

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:21'!
testObjectDiffValueAtHello
self assert: (object objectDiffValueAt: 'hello') equals: ('kitty')! !

ObjectDiffSystemTest subclass: #ODSObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:07'!
setUp
super setUp.
object := (2@3) corner: (10@15).! !

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:08'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: {'origin'. 'corner'}! !

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:27'!
testObjectDiffValueAtCorner
self assert: (object objectDiffValueAt: 'corner') equals: (10@15)! !

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:23'!
testObjectDiffValueAtOrigin
self assert: (object objectDiffValueAt: 'origin') equals: (2@3)! !

ObjectDiffSystemTest subclass: #ODSSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:09'!
setUp
super setUp.
object := Set new.
object add: 10.
object add: 'joy'.
! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:09'!
testObjectDiffKeys 
self assert: object objectDiffKeys equals: (1 to: 2)! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:30'!
testObjectDiffValueAt1
self assert: ({10. 'joy'} includes: (object objectDiffValueAt: 1))! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:33'!
testObjectDiffValueAt2
self assert: ({10. 'joy'} includes: (object objectDiffValueAt: 2))! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:34'!
testObjectDiffValueAtDiffers
self deny: ((object objectDiffValueAt: 1) = (object objectDiffValueAt: 2))! !

!SequenceableCollection methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 22:21'!
objectDiffKeys
^self isEmpty
	ifTrue: [Array new]
	ifFalse: [1 to: self size]! !

!SequenceableCollection methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:18'!
objectDiffValueAt: anInteger 
^self at: anInteger! !

Object subclass: #DiffSheet
	instanceVariableNames: 'leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:46'!
canOpenInnerDifference
^self comparisonResult canOpenInnerDifference! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:45'!
canOpenInnerDifferenceAtKey: anObject
^self comparisonResult canOpenInnerDifferenceAtKey: anObject
! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 01:46'!
commonKeys
|keySet|
keySet := Set new.
keySet addAll: leftSideObject objectDiffKeys.
keySet addAll: rightSideObject objectDiffKeys.
^keySet asArray! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:01'!
comparisonResult
leftSideObject == rightSideObject ifTrue: [^KSIdentical new comparee: leftSideObject].
leftSideObject = rightSideObject ifTrue: [^KSEqual new comparee: leftSideObject].
^KSDifferenceInDetail leftSideObject: leftSideObject rightSideObject:  rightSideObject commonKeys: self commonKeys.
	! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:37'!
comparisonResultInLiterals
^self comparisonResult literalForm
	! !

!DiffSheet methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 01:44'!
leftSideObject: anObject
leftSideObject := anObject! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 20:22'!
listItemAtRow: int1 atColumn: int2 
^self comparisonResult listItemAtRow: int1 atColumn:  int2 ! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 23:30'!
listItemOfKeyAtRow: aSmallInteger 
^self comparisonResult listItemOfKeyAtRow: aSmallInteger! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 23:32'!
listItemOfLeftSideAtRow: aSmallInteger 
^self comparisonResult listItemOfLeftSideAtRow: aSmallInteger ! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:51'!
listRowSize
^self comparisonResult listRowSize.! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:38'!
openInnerDifferenceAtKey: anObject 
^self class new
	leftSideObject: (leftSideObject objectDiffValueAt: anObject);
	rightSideObject: (rightSideObject objectDiffValueAt: anObject)! !

!DiffSheet methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 01:45'!
rightSideObject: anObject 
rightSideObject := anObject! !

Object subclass: #KSClassComparison
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

KSClassComparison subclass: #KSDifferentClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSDifferentClass methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:32'!
literalForm
^{#class. #different}! !

KSClassComparison subclass: #KSSameClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSSameClass methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 10:29'!
literalForm
^{#class. #same}! !

Object subclass: #KSComparison
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

KSComparison subclass: #KSDifferenceInDetail
	instanceVariableNames: 'classComparison insideComparisons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSDifferenceInDetail classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:01'!
leftSideObject: object1 rightSideObject: object2 commonKeys: anArray 
^self new
	classComparison: (object1 class = object2 class ifTrue: [KSSameClass new] ifFalse: [KSDifferentClass new]);
	insideComparisons: (anArray collect: [:key| (KSInsideComparison leftSideObject: object1 rightSideObject: object2 key: key)])
! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:14'!
canOpenInnerDifference
^insideComparisons anySatisfy: [:each| each canOpenInnerDifference ] ! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:34'!
canOpenInnerDifferenceAtKey: aByteString 
^(insideComparisons detect: [:each| each key = aByteString]) canOpenInnerDifference! !

!KSDifferenceInDetail methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 12:00'!
classComparison: anObject
 classComparison := anObject
! !

!KSDifferenceInDetail methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 12:00'!
insideComparisons: anArray 
insideComparisons := anArray ! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:07'!
leftSideObject
^'hell'! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 20:26'!
listItemAtRow: anInteger atColumn: anInteger2 
anInteger = 1 ifTrue: [^self leftSideObject].
self shouldBeImplemented.
! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 23:37'!
listItemOfLeftSideAtRow: aSmallInteger 
aSmallInteger = 1
	ifTrue: [^insideComparisons first leftSideObject printString].
self shouldBeImplemented! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:51'!
listRowSize
^1+1+insideComparisons size! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:13'!
literalForm
^Array streamContents: [:stream| stream nextPut: classComparison literalForm; nextPutAll: insideComparisons literalForm]! !

KSComparison subclass: #KSEqual
	instanceVariableNames: 'comparee'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:46'!
canOpenInnerDifference
^false! !

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:45'!
canOpenInnerDifferenceAtKey: anObject 
^false! !

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:02'!
comparee: anObject 
comparee := anObject! !

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 20:22'!
listItemAtRow: one atColumn: anInteger  
[one = 1] assert.
^self! !

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 23:30'!
listItemOfKeyAtRow: aSmallInteger 
^'equal'! !

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:51'!
listRowSize
^1! !

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 10:23'!
literalForm
^#equal! !

KSComparison subclass: #KSIdentical
	instanceVariableNames: 'comparee'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:55'!
canOpenInnerDifference
^false! !

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:55'!
canOpenInnerDifferenceAtKey: anObject 
^false! !

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:01'!
comparee: anObject 
comparee := anObject! !

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 23:34'!
comparisonResult
	self shouldBeImplemented.! !

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 20:24'!
listItemAtRow: one atColumn: anInteger 
[one = 1] assert.
^self 
! !

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 23:35'!
listItemOfLeftSideAtRow: aSmallInteger 
^comparee printString! !

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:02'!
listItemText
^comparee printString! !

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 21:51'!
listRowSize
^1! !

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 10:20'!
literalForm
^#identical! !

Object subclass: #KSInsideComparison
	instanceVariableNames: 'leftSideObject rightSideObject key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSInsideComparison classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:19'!
leftSideObject: object1 rightSideObject: object2 key: key 
|properClass|
properClass := (object1 objectDiffHasKey: key) ifTrue: [ (object2 objectDiffHasKey: key) ifTrue: [|partLeft partRight| partLeft := object1 objectDiffValueAt: key. partRight := object2 objectDiffValueAt: key.(partLeft==partRight ifTrue: [KSPartIdentical ] ifFalse: [partLeft=partRight ifTrue: [KSPartEqual ] ifFalse: [KSPartDifferent ]])] ifFalse: [KSRightPartMissing ]] ifFalse: [KSLeftPartMissing ].

^properClass new
	leftSideObject: object1;
	rightSideObject: object2;
	key: key! !

!KSInsideComparison methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 13:34'!
key

	^ key! !

!KSInsideComparison methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 14:27'!
key: anObject 
key := anObject ! !

!KSInsideComparison methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 13:33'!
leftSideObject: anObject 
leftSideObject := anObject ! !

!KSInsideComparison methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:19'!
literalForm
^{key. self insideComparisonLiteral}! !

!KSInsideComparison methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 13:33'!
rightSideObject: anObject 
rightSideObject := anObject ! !

KSInsideComparison subclass: #KSLeftPartMissing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSLeftPartMissing methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:19'!
insideComparisonLiteral
^#leftMissing! !

KSInsideComparison subclass: #KSPartDifferent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSPartDifferent methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:28'!
canOpenInnerDifference
^true! !

!KSPartDifferent methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:20'!
insideComparisonLiteral
^#different! !

KSInsideComparison subclass: #KSPartEqual
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSPartEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:27'!
canOpenInnerDifference
^false! !

!KSPartEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:21'!
insideComparisonLiteral
^#equal! !

KSInsideComparison subclass: #KSPartIdentical
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSPartIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:21'!
insideComparisonLiteral
^#identical! !

!KSPartIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/29/2012 23:37'!
leftSideObject
^leftSideObject! !

KSInsideComparison subclass: #KSRightPartMissing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSRightPartMissing methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:22'!
insideComparisonLiteral
^#rightMissing! !

Object subclass: #OArrayDiffy
	instanceVariableNames: 'leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD'!

!OArrayDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:14'!
elementDiffies
^(1 to: leftSideObject size)
	collect: 
		[:key|
		ODiffy new
			leftSideObject: (leftSideObject at: key);
			rightSideObject: (rightSideObject at: key)
		]! !

!OArrayDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:10'!
leftSideObject: anObject 
leftSideObject:= anObject ! !

!OArrayDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:10'!
rightSideObject: anObject 

rightSideObject:= anObject! !

Object subclass: #ODAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet'!

Object subclass: #ODSheet
	instanceVariableNames: 'objects accesses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet'!

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
accesses
	^ accesses! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
accesses: anArray
	accesses := anArray
! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
objects
	^ objects! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
objects: anArray
	objects := anArray
! !

!ODSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:25'!
valueOfObjectAt: objectIndex byAccessAt: accessIndex
|object access|
object := objects at: objectIndex.
access := accesses at: accessIndex.
^[access value: object] on: Error do: [:ex| ex]
! !

Object subclass: #ODWorkspace
	instanceVariableNames: 'sheet cellExtent contents win'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet-GUI'!

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 18:19'!
cellMorphAtRow: rowIndex atColumn: colIndex
|cellObject morph|
cellObject := 
rowIndex = 0
	ifTrue: 
		[colIndex = 0
			ifTrue: ['objects'] 
			ifFalse: [sheet accesses at: colIndex]]
	ifFalse: 
		[colIndex = 0
			ifTrue: [sheet objects at: rowIndex]
			ifFalse: [sheet valueOfObjectAt: rowIndex byAccessAt: colIndex]].
morph := cellObject printString asMorph.
morph extent: cellExtent.
^morph! !

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 18:53'!
construct

self makeSheet.

cellExtent := 200@40.

contents := 
UITheme builder newColumn: 
	(Array streamContents: 
		[:rowStream|	
		0 to: sheet objects size do: 
			[:objectIndex|
			rowStream nextPut: 
				(UITheme builder newRow: 
					(Array streamContents: 
						[:stream|
						0 to: sheet accesses size do: 
							[:accessIndex|
							stream nextPut: (self cellMorphAtRow: objectIndex  atColumn: accessIndex)
							]
						])).
			]
]).! !

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 15:24'!
makeSheet
sheet := ODSheet new.
sheet objects: {'hello'. 19. World}.
sheet accesses: {[:o| o sizeInMemory]. [:o| o className]. [:o| o even]}.
! !

Object subclass: #ODiffy
	instanceVariableNames: 'leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD'!

!ODiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:12'!
diffies
^self ivarDiffies! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:56'!
ifIdentical: iBlock ifEqual: eBlock ifDifferent: dBlock
^leftSideObject == rightSideObject
	ifTrue: iBlock
	ifFalse: 
		[leftSideObject = rightSideObject
			ifTrue: eBlock
			ifFalse: dBlock]! !

!ODiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:57'!
instVarName
	(leftSideObject respondsTo: #instVarName) ifFalse: [self error: ''].
	(rightSideObject respondsTo: #instVarName) ifFalse: [self error: ''].
	(leftSideObject instVarName = rightSideObject instVarName) ifFalse: [self error: ''].
	^leftSideObject instVarName! !

!ODiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:33'!
ivarDiffies
^leftSideObject class instVarNames
	collect: 
		[:iName|
			OIVarDiffy new
				leftSideObject: leftSideObject;
				rightSideObject: rightSideObject;
				instVarName: iName]! !

!ODiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:59'!
ivarDiffies100
^leftSideObject class instVarNames
	collect: 
		[:iName|
			ODiffy new
				leftSideObject: (OIvarReference object: leftSideObject instVarName: iName);
				rightSideObject: (OIvarReference object: rightSideObject instVarName: iName)]! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:55'!
leftSideObject
	^ leftSideObject! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:55'!
leftSideObject: anObject
	leftSideObject := anObject! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:55'!
rightSideObject
	^ rightSideObject! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:55'!
rightSideObject: anObject
	rightSideObject := anObject! !

Object subclass: #OIVarDiffy
	instanceVariableNames: 'instVarName leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD'!

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:01'!
ifIdentical: iBlock ifEqual: eBlock ifDifferent: dBlock
|i1 i2|
i1 := self leftSideValue.
i2 := self rightSideValue.
^i1 == i2
	ifTrue: iBlock
	ifFalse: 
		[i1 = i2
			ifTrue: eBlock
			ifFalse: dBlock]! !

!OIVarDiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:36'!
instVarName
	^ instVarName! !

!OIVarDiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:35'!
instVarName: aString 
	instVarName := aString! !

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:02'!
ivarDiffies
^(self leftSideValue) class instVarNames
	collect: 
		[:iName|
			OIVarDiffy new
				leftSideObject: (self leftSideValue);
				rightSideObject: (self rightSideValue);
				instVarName: iName]! !

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:34'!
leftSideObject: anObject 
	leftSideObject := anObject! !

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:00'!
leftSideValue.
^leftSideObject instVarAt: (leftSideObject class instVarNames indexOf: instVarName)! !

!OIVarDiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:35'!
rightSideObject: anObject 
	rightSideObject := anObject! !

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:01'!
rightSideValue.
^rightSideObject instVarAt: (rightSideObject class instVarNames indexOf: instVarName)! !

Object subclass: #OIvarReference
	instanceVariableNames: 'object instVarName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD'!

!OIvarReference classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:53'!
object: anObject instVarName: aString 

^self new
	object: anObject;
	instVarName: aString;
	yourself! !

!OIvarReference methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:47'!
instVarName
	^ instVarName! !

!OIvarReference methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:47'!
instVarName: aString
	instVarName := aString
! !

!OIvarReference methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:47'!
object
	^ object! !

!OIvarReference methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:47'!
object: anObject
	object := anObject! !

!OIvarReference methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:50'!
value

	^object instVarAt: (object class instVarNames indexOf: instVarName)! !

!Object methodsFor: '*ObjectDiff' stamp: 'HwaJong 10/3/2012 10:48'!
diff: anObject 
|obj1 obj2 pr|
obj1 := self.
obj2 := anObject.

pr:= [:obj| obj className, String cr, (obj longPrintStringLimitedTo: 20000)].
(DiffMorph new from: (pr value:obj1) to: (pr value:obj2)) openInWindowLabeled: obj1 printString, ' vs ', obj2 printString.
! !

!Object methodsFor: '*ObjectDiff' stamp: 'HwaJong 10/28/2012 21:08'!
listItemText
^self printString! !

!Object methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 02:29'!
objectDiffHasKey: anObject
^self objectDiffKeys includes: anObject ! !

!Object methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 22:18'!
objectDiffKeys
^self class instVarNames.! !

!Object methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:25'!
objectDiffValueAt: aString 
^self instVarAt: (self class instVarNames indexOf: aString)! !

Object subclass: #ObjectDiffGUI
	instanceVariableNames: 'diffSheet diffListSelection'
	classVariableNames: 'IconForEqual IconForIdentical IconForLeftMissing IconForRightMissing'
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

!ObjectDiffGUI classSide methodsFor: 'defaults' stamp: 'HwaJong 10/28/2012 17:07'!
defaultIconForEqual
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 83886080 838860800 117440512 16777215 16777215 16777215 16777215 16777215 83886080 838860800 117440512 16777215 16777215 16777215 16777215 1493172224 3372220416 3355443200 3187671040 16777215 16777215 16777215 16777215 1493172224 3372220416 3355443200 3187671040 16777215 16777215 16777215 2181038080 3808428032 3422552064 1308622848 2835349504 1174405120 16777215 16777215 2181038080 3808428032 3422552064 1308622848 2835349504 1174405120 16777215 117440512 2734686208 2868903936 4026531840 4177526784 2751463424 1644167168 16777215 117440512 2734686208 2868903936 4026531840 4177526784 2751463424 1644167168 16777215 167772160 3170893824 2013265920 4143972352 3841982464 3472883712 1946157056 16777215 167772160 3170893824 2013265920 4143972352 3841982464 3472883712 1946157056 16777215 1073741824 3170893824 2147483648 4043309056 3573547008 3472883712 2063597568 16777215 1073741824 3170893824 2147483648 4043309056 3573547008 3472883712 2063597568 16777215 1207959552 2667577344 2600468480 3909091328 3271557120 2952790016 2566914048 16777215 1207959552 2667577344 2600468480 3909091328 3271557120 2952790016 2566914048 16777215 855638016 2533359616 2768240640 2634022912 3724541952 3019898880 2583691264 16777215 855638016 2533359616 2768240640 2634022912 3724541952 3019898880 2583691264 16777215 973078528 3036676096 2533359616 2080374784 4026531840 3355443200 2566914048 16777215 973078528 3036676096 2533359616 2080374784 4026531840 3355443200 2566914048 16777215 469762048 2717908992 2617245696 1895825408 3875536896 3221225472 1946157056 16777215 469762048 2717908992 2617245696 1895825408 3875536896 3221225472 1946157056 16777215 134217728 2734686208 2868903936 2650800128 3321888768 3036676096 2113929216 16777215 134217728 2734686208 2868903936 2650800128 3321888768 3036676096 2113929216 16777215 16777215 2868903936 1056964608 3053453312 3154116608 2701131776 1778384896 16777215 16777215 2868903936 1056964608 3053453312 3154116608 2701131776 1778384896 16777215 16777215 1879048192 1795162112 654311424 2533359616 2936012800 318767104 16777215 16777215 1879048192 1795162112 654311424 2533359616 2936012800 318767104 16777215 16777215 33554432 1728053248 3003121664 2667577344 268435456 16777215 16777215 16777215 33554432 1728053248 3003121664 2667577344 268435456 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: (0@0)).! !

!ObjectDiffGUI classSide methodsFor: 'defaults' stamp: 'HwaJong 10/28/2012 17:04'!
defaultIconForIdentical
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 83886080 838860800 117440512 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1493172224 3372220416 3355443200 3187671040 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2181038080 3808428032 3422552064 1308622848 2835349504 1174405120 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 117440512 2734686208 2868903936 4026531840 4177526784 2751463424 1644167168 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 167772160 3170893824 2013265920 4143972352 3841982464 3472883712 1946157056 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1073741824 3170893824 2147483648 4043309056 3573547008 3472883712 2063597568 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 2667577344 2600468480 3909091328 3271557120 2952790016 2566914048 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 855638016 2533359616 2768240640 2634022912 3724541952 3019898880 2583691264 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 973078528 3036676096 2533359616 2080374784 4026531840 3355443200 2566914048 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 469762048 2717908992 2617245696 1895825408 3875536896 3221225472 1946157056 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 134217728 2734686208 2868903936 2650800128 3321888768 3036676096 2113929216 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2868903936 1056964608 3053453312 3154116608 2701131776 1778384896 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1879048192 1795162112 654311424 2533359616 2936012800 318767104 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 33554432 1728053248 3003121664 2667577344 268435456 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: (0@0))! !

!ObjectDiffGUI classSide methodsFor: 'defaults' stamp: 'HwaJong 10/28/2012 17:12'!
defaultIconForLeftMissing
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 67108864 184549376 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 536870912 1526726656 16777215 520093696 1493172224 184549376 16777215 16777215 16777215 16777215 335544320 335544320 16777215 16777215 16777215 16777215 788529152 2432696320 16777215 167772160 1610612736 2499805184 402653184 16777215 16777215 318767104 3506438144 3439329280 2902458368 83886080 16777215 16777215 1040187392 2684354560 16777215 16777215 16777215 117440512 150994944 16777215 16777215 2214592512 3489660928 771751936 3321888768 1157627904 16777215 16777215 469762048 855638016 16777215 16777215 16777215 16777215 16777215 16777215 16777216 3204448256 2969567232 2332033024 3523215360 2550136832 16777215 16777215 67108864 167772160 16777215 16777215 16777215 184549376 150994944 16777215 16777215 2785017856 2013265920 3070230528 3539992576 2399141888 16777215 16777215 738197504 1929379840 16777215 16777215 16777215 1157627904 1996488704 16777215 16777215 2298478592 2432696320 3221225472 2499805184 2013265920 16777215 16777215 905969664 2483027968 16777215 16777215 16777215 1728053248 2785017856 16777215 16777215 2231369728 2801795072 2986344448 2181038080 2466250752 16777215 16777215 1157627904 1258291200 16777215 16777215 16777215 1174405120 1560281088 16777215 16777215 2818572288 3288334336 3573547008 3690987520 2634022912 16777215 16777215 754974720 687865856 16777215 16777215 16777215 100663296 100663296 16777215 16777215 3120562176 3741319168 4060086272 3858759680 2583691264 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2432696320 3758096384 4110417920 3741319168 2717908992 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777216 3271557120 3892314112 3774873600 3338665984 2667577344 16777215 16777215 16777215 184549376 16777215 16777215 16777215 83886080 16777216 16777215 16777215 2902458368 1224736768 1979711488 3288334336 1426063360 16777215 16777215 16777215 1476395008 1962934272 16777215 16777215 1962934272 872415232 16777215 16777215 2415919104 973078528 1744830464 2348810240 536870912 16777215 16777215 16777215 50331648 1996488704 587202560 16777215 3187671040 251658240 16777215 16777215 1711276032 3271557120 2734686208 2130706432 16777215 16777215 16777215 16777215 16777215 16777215 16777215 268435456 1543503872 16777215 16777215 16777215 50331648 1744830464 2332033024 50331648 16777215 16777215)
	offset: (0@0)).! !

!ObjectDiffGUI classSide methodsFor: 'defaults' stamp: 'HwaJong 10/28/2012 17:10'!
defaultIconForRightMissing
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 16777215 16777215 33554432 16777215 16777215 16777215 16777215 16777215 16777215 16777215 922746880 1795162112 167772160 16777215 16777215 16777215 16777215 218103808 2734686208 3238002688 721420288 16777215 16777215 16777215 16777215 16777215 335544320 2046820352 939524096 16777215 16777215 16777215 16777215 1090519040 3238002688 2701131776 3271557120 335544320 16777215 16777215 16777215 184549376 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1174405120 3992977408 3305111552 3254779904 1526726656 16777215 16777215 16777215 1761607680 134217728 16777215 16777215 83886080 50331648 16777215 16777215 2415919104 4110417920 3456106496 3187671040 2667577344 16777215 16777215 16777215 1409286144 50331648 16777215 16777215 1258291200 1090519040 16777215 16777215 3388997632 3976200192 3623878656 3305111552 2902458368 16777215 16777215 16777215 570425344 989855744 16777215 16777215 1459617792 1660944384 16777215 16777215 3523215360 3590324224 3657433088 3791650816 2785017856 16777216 16777215 16777215 939524096 1744830464 16777215 16777215 150994944 285212672 16777215 16777215 3288334336 3338665984 3607101440 3909091328 2801795072 16777215 16777215 16777215 503316480 1090519040 16777215 16777215 16777215 16777215 16777215 16777215 3003121664 3573547008 3791650816 3808428032 2919235584 16777215 16777215 16777215 16777216 150994944 16777215 16777215 16777215 16777215 16777215 16777216 2902458368 3388997632 3992977408 3137339392 3305111552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777216 16777215 285212672 2785017856 3204448256 4110417920 2617245696 3556769792 16777215 16777215 16777215 201326592 369098752 16777215 16777215 503316480 989855744 16777215 335544320 2248146944 3992977408 4177526784 3254779904 3523215360 134217728 16777215 16777215 704643072 1342177280 16777215 16777215 855638016 1996488704 16777215 67108864 251658240 4060086272 3976200192 1577058304 3087007744 83886080 16777215 16777215 335544320 771751936 16777215 16777215 469762048 1140850688 16777215 16777215 16777215 3791650816 3321888768 3019898880 503316480 16777215 16777215 16777215 16777215 16777215 16777215 16777215 335544320 16777215 16777215 16777215 16777215 2785017856 2432696320 452984832 16777215 16777215 16777215 16777215 16777216 704643072 1325400064 150994944 318767104 16777215 16777215 16777215 16777215 385875968 16777216 33554432 16777215 16777215 16777215 16777215 16777215 520093696 1291845632 184549376 16777215 16777215)
	offset: (0@0)).! !

!ObjectDiffGUI classSide methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 17:06'!
iconForEqual
^IconForEqual setDefault: #defaultIconForEqual for: self withSetter: #iconForEqual:! !

!ObjectDiffGUI classSide methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 17:07'!
iconForEqual: aForm 
IconForEqual := aForm! !

!ObjectDiffGUI classSide methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 17:01'!
iconForIdentical
^IconForIdentical setDefault: #defaultIconForIdentical for: self withSetter: #iconForIdentical:! !

!ObjectDiffGUI classSide methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 17:04'!
iconForIdentical: aForm 
IconForIdentical := aForm ! !

!ObjectDiffGUI classSide methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 17:11'!
iconForLeftMissing
^IconForLeftMissing setDefault: #defaultIconForLeftMissing for: self withSetter: #iconForLeftMissing:! !

!ObjectDiffGUI classSide methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 17:12'!
iconForLeftMissing: aForm 
IconForLeftMissing := aForm ! !

!ObjectDiffGUI classSide methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 17:09'!
iconForRightMissing
^IconForRightMissing setDefault: #defaultIconForRightMissing for: self withSetter: #iconForRightMissing:! !

!ObjectDiffGUI classSide methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 17:10'!
iconForRightMissing: aForm 
IconForRightMissing := aForm ! !

!ObjectDiffGUI classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 19:41'!
on: aDiffSheet
^self new
	model: aDiffSheet! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/28/2012 17:38'!
balloonTextForNode: aPluggableTreeItemNode 
^'bal bal'! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/28/2012 19:45'!
diffDetailListTreeItems
^(diffSheet isNil
	ifTrue: [1 to: 5]
	ifFalse: [diffSheet commonKeys]) collect: [:each| PluggableTreeItemNode with: each model: self ]! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/28/2012 19:38'!
diffListSelection
^diffListSelection isNil
	ifTrue: [0]
	ifFalse: [diffListSelection item].! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/28/2012 19:38'!
diffListSelection: aPluggableTreeItemNode 
diffListSelection := aPluggableTreeItemNode.
self changed: #diffListSelection! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/28/2012 19:35'!
hasNodeContents: object
^false! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/28/2012 19:50'!
iconOfNode: aPluggableTreeItemNode 
^aPluggableTreeItemNode item
	ifIdentical: [self class iconForRightMissing.] ifEqual: [self class iconForRightMissing.] ifDifferent: [self class iconForRightMissing.] ifLeftMissing: [self class iconForLeftMissing.] ifRightMissing: [self class iconForRightMissing.]
! !

!ObjectDiffGUI methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 19:43'!
model: aDiffSheet 
diffSheet := aDiffSheet! !

!ObjectDiffGUI methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:16'!
open
|builder list window|
builder := UITheme builder.
list := builder newTreeFor: self list: #diffDetailListTreeItems selected: #diffListSelection changeSelected: #diffListSelection:.
window := list openInWindowLabeled: 'Diffy Diffy Diff Diff'.
window extent: 320@460.! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/28/2012 20:16'!
printNode: aPluggableTreeItemNode 
^aPluggableTreeItemNode item printString! !
